local lg = love.graphics
player = {x = 160, y = 160, img, speed = 5}
sign = {x = 40, y = 480, img}

background = nil

canMove = true
black = {0, 0, 0, 255}

signText = { }
signText.line1 = {text, tag = 1}
signText.line2 = {text, tag = 2}
signText.line3 = {text, tag = 3}
signText.line4 = {text, tag = 4}
signText.line5 = {text, tag = 5}


textLine = {one, two, three}
textLine.one = {x = (sign.x + 20), y = (sign.y + 15), text = {black, "Line 1"}} -- This Text is Just A Placeholder
textLine.two = {x = (sign.x + 20), y = (sign.y + 45), text = {black, "Line 2"}} -- This Text is Just A Placeholder
textLine.three = {x = (sign.x + 20), y = (sign.y + 75), text = { black, "Line 3"}} -- This Text is Just A Placeholder

font = nil

signBool = false
--###############################################################--
function love.load()
	player.img = lg.newImage('player.png')
	sign.img = lg.newImage('sign.png')
	background = lg.newImage('background.png')
	
	signLoad()
	
	canMove = true
	signBool = false
end

function love.update()
	playerInput()
	signUpdate()
	
	 if love.keyboard.isDown('space') then
	 	signBool = true
	end
	
	 if love.keyboard.isDown('escape') then
	 	signBool = false
	end
end

function love.draw()
	lg.draw(background, 0, 0)
	lg.draw(player.img, player.x, player.y)
	
	signDraw()
end

--###############################################################--

function playerInput()
	if love.keyboard.isDown('left', 'a') then
		if player.x > 0 and canMove then
			player.x = player.x - (1 * player.speed)
		end
	end
	
	if love.keyboard.isDown('right','d') then 
		if player.x < (lg.getWidth() - player.img:getWidth()) and canMove then
			player.x = player.x + (1 * player.speed)
		end
	end
	
	if love.keyboard.isDown('up', 'w') then
		if player.y > 0 and canMove then
			player.y = player.y - (1 * player.speed)
		end
	end
	
	if love.keyboard.isDown('down','s') then 
		if player.y < (lg.getHeight() - player.img:getHeight()) and canMove then
			player.y = player.y + (1 * player.speed)
		end
	end
	
end

function signLoad()
	signText.line1.text = {black, "This is line 1 of the Sign"}
	signText.line2.text = {black, "This is line 2 of the Sign"}
	signText.line3.text = {black, "This is line 3 of the Sign"}
	signText.line4.text = {black, "This is line 4 of the Sign"}
	signText.line5.text = {black, "This is line 5 of the Sign"}
	
	for l, line in ipairs(textLine) do --This is the Problem Child
		if line.tag == 1 then
			textLine.one.text = signText.line1.text 
		end
		if line.tag == 2 then
			textLine.two.text = signText.line2.text
		end
		if line.tag == 3 then
			textLine.three.text = signText.line3.text 
		end
	end
	
	scrollTimer = 0
	font = lg.newFont('font.ttf', 32)
	lg.setFont(font)
end

function signUpdate()
	if signBool then
		canMove = false
		signScroll()
	else
		canMove = true
	end
end

function signDraw()
	if signBool then
		lg.draw(sign.img, sign.x, sign.y)
		lg.print(textLine.one.text, textLine.one.x, textLine.one.y)
		lg.print(textLine.two.text, textLine.two.x, textLine.two.y)
		lg.print(textLine.three.text, textLine.three.x, textLine.three.y)
	end
end

function signScroll()
	for l, line in ipairs(signText) do
		if scrollBool and love.keyboard.isDown('return') and scrollTimer > 10 then
			line.tag = line.tag - 1
			scroolTimer = 0
		end
		
		if line.tag == 1 then
			textLine.one.text = line.text
		end
		if line.tag == 2 then
			textLine.two.text = line.text
		end
		if line.tag == 3 then
			textLine.three.text = line.text
		end
		if line.tag == 4 then
			scrollBool = true
		else
			scrollBool = false	
		end
	end

	scrollTimer = scrollTimer + 1
end